from StringIO import StringIO
from Products.CMFCore.utils import getToolByName

def install(self):
    portal_types = getToolByName(self,'portal_types')
    out = StringIO()
    out.write('Adding nifty "lexis" tab ...\n')
    types = portal_types.listTypeInfo()
    for type_obj in types:
	type_id = type_obj.getId()
	if type_id in ['BibliographyFolder','ArticleReference']:
	    out.write("  to %s ... " % (type_id,))
	    type_actions = type_obj.listActions()
	    if not 'lexis' in [x.getId() for x in type_actions]:
		type_obj.addAction(id='lexis',
		                   name='Lexis',
				   action='biblexis_form',
				   condition=None,
				   permission='Modify portal content',
				   category='object',
				   visible=1,
				   REQUEST=None)
		print >>out, " added.\n"
	    else:
		print >>out, " present already, skipping.\n"
    return out.getvalue()

def uninstall(self):
    out = StringIO()
    portal_types = getToolByName(self,'portal_types')
    types = portal_types.listTypeInfo()
    print >>out, 'Removing nifty "lexis" tab ...\n'
    for type_obj in types:
	type_id = type_obj.getId()
	if type_id in ['BibliographyFolder','ArticleReference']:
	    out.write("  from %s ... " % (type_obj.getId(),))
	    type_actions = type_obj.listActions()
	    if 'lexis' in [x.getId() for x in type_actions]:
		pos = [x.getId() for x in type_actions].index('lexis')
		type_obj.deleteActions(selections=(pos,))
		out.write("deleted.\n")
	    else:
		out.write("none present, skipping.\n")
	    out.write("\n")
    return out.getvalue()
