## Controller Python Script "biblexis_parse"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=biblexisheader,url='',id=None,type_name='ArticleReference',script_id=None
##title=Run parser before traversing to the editing template

from DateTime import DateTime
from Products.CMFPlone.utils import transaction_note
REQUEST=context.REQUEST

if id is None:
    id=context.generateUniqueId(type_name)

if type_name is None:
    raise Exception, 'Type name not specified'

if context.portal_factory.getFactoryTypes().has_key(type_name):
    o = context.restrictedTraverse('portal_factory/' + type_name + '/' + id)
    portal_status_message = None
    transaction_note('Initiated creation of %s with id %s in %s' % (o.getTypeInfo().getId(), id, context.absolute_url()))
else:
    new_id = context.invokeFactory(id=id, type_name=type_name)
    if new_id is None or new_id == '':
       new_id = id
    o=getattr(context, new_id, None)
    tname = o.getTypeInfo().Title()
    portal_status_message = tname + ' has been created.'
    transaction_note('Created %s with id %s in %s' % (o.getTypeInfo().getId(), new_id, context.absolute_url()))

if o is None:
    raise Exception

# Alter fields

biblexis_tool = context.biblexis_tool
biblexisheader=biblexisheader.replace('\r','')
res = biblexis_tool.parse(biblexisheader)

schema = o.Schema()
field = schema.getField('publication_url')
mutator = field.getMutator(schema)
mutator(url)

if res:
    for key in res.keys():
        field = schema.getField(key)
        mutator = field.getMutator(schema)
        mutator(res[key])
    state.set(status='success',portal_status_message='Succeeded, please check')
else:
    state.set(status='failure',portal_status_message='Failed, enter by hand')
    


if o.getTypeInfo().getActionById('edit', None) is None:
    state.setStatus('success_no_edit')

if script_id:
    state.setId(script_id)


return state.set(context=o)
