import os, sys

if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.CMFPlone.tests.PloneTestCase import PloneTestCase
from Products.BibLexis.tests import setup



class TestParser(PloneTestCase):
    '''Test a BibLexis install'''

    ZopeTestCase._print('Will test the parser\n')

    FIXME001 = {'publication_url': '', 'journal': 'Kan. L. Rev.', 'title': 'Japanese Civil Procedure in Comparative Law Perspective', 'number': '', 'publication_year': '1998', 'volume': '46', 'authors': [{'lastname': 'Kojima', 'firstnames': 'Takeshi', 'homepage': ''}], 'pages': '687'}
    FIXME002 = {'publication_url': '', 'journal': "Law & Pol'y Int'l Bus.", 'title': 'Cooperation, Conflict, and Convergence in Japanese Finance: Evidence From the "Jusen" Problem', 'number': '', 'publication_year': '1997', 'volume': '29', 'authors': [{'lastname': 'Milhaupt', 'firstnames': 'Curtis J.', 'homepage': ''}, {'lastname': 'Miller', 'firstnames': 'Geoffrey P.', 'homepage': ''}], 'pages': '1'}
    FIXME003 = {'publication_url': '', 'journal': 'A.J.I.L.', 'title': 'Surrender, Occupation, and Private Property in International Law: An Evaluation of U.S. Practice in Japan. By Nisuke Ando.', 'number': '', 'publication_year': '1993', 'volume': '87', 'authors': [{'lastname': 'Heslop', 'firstnames': 'Jessica', 'homepage': ''}, {'lastname': 'Roberto', 'firstnames': 'Joel', 'homepage': ''}], 'pages': '684'}
    FIXME004 = {'publication_url': '', 'journal': "Brooklyn J. Int'l L.", 'title': 'Intellectual Property Rights, Conflict of Laws and International Jurisdiction: Applicability of Ali Principles in Japan?', 'number': '', 'publication_year': '2005', 'volume': '30', 'authors': [{'lastname': 'Kono', 'firstnames': 'Toshiyuki', 'homepage': ''}], 'pages': '865'}
    FIXME005 = {'publication_url': '', 'journal': "Fla. J. Int'l L.", 'title': 'The Elimination of Political Groups Under International Law and the Constitution of Political Claims', 'number': '', 'publication_year': '2003', 'volume': '15', 'authors': [{'lastname': 'Benavides-Vanegas', 'firstnames': 'Farid Samir', 'homepage': ''}], 'pages': '575'}
    FIXME006 = {'publication_url': '', 'journal': "Asian-Pacific L. & Pol'y J.", 'title': 'The WTO Legalistic Approach and East Asia: From the Legal Culture Perspective', 'number': '', 'publication_year': '2000', 'volume': '1', 'authors': [{'lastname': 'Peng', 'firstnames': 'Shin-Yi', 'homepage': ''}], 'pages': '13'}
    FIXME007 = {'publication_url': '', 'journal': 'Chi.-Kent. L. Rev.', 'title': 'The Development of Law in the Ancient Near East: Justice in Western Asia in Antiquity, Or: Why No Laws Were Needed!', 'number': '', 'publication_year': '1995', 'volume': '70', 'authors': [{'lastname': 'Lemche', 'firstnames': 'Niels Peter', 'homepage': ''}], 'pages': '1695'}
    
    def checkKeySanity(self,wanted,found):
	keys = []
	for k in wanted.keys():
	    if k in found.keys():
		keys.append(k)
	    else:
		self.failUnless(k in found.keys(),'expected key %s not in result' % (k,))
	for k in found.keys():
	    if k in wanted.keys():
		if not k in keys:
		    keys.append(k)
	    else:
		self.failUnless(k in wanted.keys(),'extraneous key %s in result' % (k,))
	return keys
    
    def checkResult(self,wanted,found):
	keys = self.checkKeySanity(wanted,found)
	for k in keys:
	    if k == 'authors':
		aw_list = wanted[k]
		af_list = found[k]
		self.failUnless(len(aw_list) == len(af_list),'wrong number of authors')
		for pos in range(0,len(aw_list),1):
		    akeys = self.checkKeySanity(aw_list[pos],af_list[pos])
		    for a in akeys:
			w = aw_list[pos][a]
			f = af_list[pos][a]
			self.failUnless(w == f,'expected %s for key %s under authors key, got %s' % (w,a,f))
	    else:
		w = wanted[k]
		f = found[k]
		self.failUnless(w == f, 'expected %s for key %s, got %s' % (w,k,f))

    def runTest(self,arg,snoop=None):
	if not snoop:
	    wanted = eval('self.%s' % (arg,))
	fn = eval('setup.%s' % (arg,))
	text = open(fn, 'r').read()
	found = self.portal.biblexis_tool.parse(text)
	if not snoop:
	    self.checkResult(wanted,found)
	return found
	
    def afterSetUp(self):
        pass

    # the individual tests
    def testFixme001(self):
	found = self.runTest('FIXME001')
	#ZopeTestCase._print('%s' % (found,))

    def testFixme002(self):
	found = self.runTest('FIXME002')
	#ZopeTestCase._print('%s' % (found,))
	    
    def testFixme003(self):
	found = self.runTest('FIXME003')
	#ZopeTestCase._print('%s' % (found,))
	    
    def testFixme004(self):
	found = self.runTest('FIXME004')
	#ZopeTestCase._print('%s' % (found,))
	    
    def testFixme005(self):
	found = self.runTest('FIXME005')
	#ZopeTestCase._print('%s' % (found,))
	    
    def testFixme006(self):
	found = self.runTest('FIXME006')
	#ZopeTestCase._print('%s' % (found,))

    def testFixme007(self):
	found = self.runTest('FIXME007',snoop=0)
	#ZopeTestCase._print('%s' % (found,))
	    
	    
    # end of the individual tests

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestParser))
    return suite

if __name__ == '__main__':
    framework()
